package com.minerarcana.floralchemy.block;

import com.minerarcana.floralchemy.FloraObjectHolder;

import net.minecraft.block.Block;
import net.minecraft.block.properties.IProperty;
import net.minecraft.block.properties.PropertyDirection;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.init.Blocks;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumFacing.Axis;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

public class BlockGlimmerweed extends BlockBaseBush {

	//Only need one vertical state
	public static final PropertyDirection FACING = PropertyDirection.func_177714_a("facing");
	
	protected static final AxisAlignedBB REED_AABB = new AxisAlignedBB(0.125D, 0.0D, 0.125D, 0.875D, 1.0D, 0.875D);
	protected static final AxisAlignedBB WEST_AABB = new AxisAlignedBB(0.0D, 0.0D, 0.0D, 0.0625D, 1.0D, 1.0D);
    protected static final AxisAlignedBB EAST_AABB = new AxisAlignedBB(0.9375D, 0.0D, 0.0D, 1.0D, 1.0D, 1.0D);
    protected static final AxisAlignedBB NORTH_AABB = new AxisAlignedBB(0.0D, 0.0D, 0.0D, 1.0D, 1.0D, 0.0625D);
    protected static final AxisAlignedBB SOUTH_AABB = new AxisAlignedBB(0.0D, 0.0D, 0.9375D, 1.0D, 1.0D, 1.0D);
	
    public BlockGlimmerweed() {
        super("glimmerweed", "water");
        this.func_149715_a(0.7F);
    }
    
    @Override
    public AxisAlignedBB func_185496_a(IBlockState state, IBlockAccess source, BlockPos pos)
    {
        state = state.func_185899_b(source, pos);
        
        switch(state.func_177229_b(FACING)) {
        	case SOUTH: return SOUTH_AABB;
        	case NORTH: return NORTH_AABB;
        	case WEST: return WEST_AABB;
        	case EAST: return EAST_AABB;
			default: return REED_AABB; 
        }
    }
    
    @Override
    public IBlockState func_176203_a(int meta) {
        return this.func_176223_P().func_177226_a(FACING, EnumFacing.func_82600_a(meta)); 
    }

    @Override
    public int func_176201_c(IBlockState state) {
        return state.func_177229_b(FACING).func_176745_a();
    }
    
    @Override
    protected BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, new IProperty[] { FACING });
    }

    @Override
    public boolean func_185514_i(IBlockState state)
    {
        return state.func_177230_c() == Blocks.field_150346_d || state.func_177230_c() == Blocks.field_150349_c || state.func_177230_c() == Blocks.field_150348_b || state.func_177230_c() == this || state.func_177230_c() == FloraObjectHolder.FLOODED_SOIL;
    }
    
    @Override
    public boolean func_176198_a(World worldIn, BlockPos pos, EnumFacing side)
    {
    	IBlockState state = worldIn.func_180495_p(pos.func_177972_a(side.func_176734_d()));
    	if(side.func_176740_k() == Axis.Y) {
    		return func_185514_i(state);
    	}
    	//Prevent sideways chaining of glimmerweed whilst still allowing vertical stacking
    	else {
    		return worldIn.func_180495_p(pos.func_177972_a(side.func_176734_d())).func_177230_c() != this ? func_185514_i(state) : false;
    	}
    }
    
    @Override
    public void func_189540_a(IBlockState state, World worldIn, BlockPos pos, Block blockIn, BlockPos fromPos)
    {
    	if (!worldIn.field_72995_K)
        {
    		EnumFacing facing = state.func_177229_b(FACING);
    		if(!func_185514_i(worldIn.func_180495_p(pos.func_177972_a(facing)))) {
    			this.func_176226_b(worldIn, pos, state, 0);
                worldIn.func_175698_g(pos);
    		}
        }
    }
    
    @Override
    public IBlockState func_180642_a(World worldIn, BlockPos pos, EnumFacing facing, float hitX, float hitY, float hitZ, int meta, EntityLivingBase placer)
    {
    	return this.func_176223_P().func_177226_a(FACING, facing.func_176734_d());
    }
}
